//=============================================================================

#define CATCH_CONFIG_MAIN
#include "catch.hpp"
#include <sstream>
#include <string>
#include "hellolib.hpp"
using namespace std;

//-----------------------------------------------------------------------------

TEST_CASE("Name einlesen - einfacher Fall")
{
   istringstream iss("Tom");
   ostringstream oss;
   REQUIRE(readUserName(iss, oss) == "Tom");
   REQUIRE(oss.str() == "Name: ");
}

TEST_CASE("Name einlesen - komplexer Fall")
{
   istringstream iss("Tom Mustermann");
   ostringstream oss;
   REQUIRE(readUserName(iss, oss) == "Tom Mustermann");
   REQUIRE(oss.str() == "Name: ");
}

TEST_CASE("Name einlesen - widerborstiger User")
{
   istringstream iss("\nMax");
   ostringstream oss;
   REQUIRE(readUserName(iss, oss) == "Max");
   REQUIRE(oss.str() == "Name: Nicht nichts\nName: ");
}

TEST_CASE("Name einlesen - sehr widerborstiger User")
{
   istringstream iss("\n\n ");
   ostringstream oss;
   REQUIRE(readUserName(iss, oss) == " ");
   REQUIRE(oss.str() == "Name: Nicht nichts\nName: Nicht nichts\nName: ");
}

TEST_CASE("Hallo - mit einfachem Namen")
{
   ostringstream oss;
   hello(oss, "Tom");
   REQUIRE(oss.str() == "**************\n*            *\n* Hallo Tom! *\n*            *\n**************\n");
}

TEST_CASE("Hallo - mit einem Buchstaben")
{
   ostringstream oss;
   hello(oss, " ");
   REQUIRE(oss.str() == "************\n*          *\n* Hallo  ! *\n*          *\n************\n");
}

TEST_CASE("Hallo - mit komplexem Namen")
{
   ostringstream oss;
   hello(oss, "Max Muster");
   REQUIRE(oss.str() == "*********************\n*                   *\n* Hallo Max Muster! *\n*                   *\n*********************\n");
}

TEST_CASE("Hauptprogramm")
{
   istringstream iss("Eva");
   ostringstream oss;
   mymain(iss, oss);
   REQUIRE(oss.str() == "Name: \n**************\n*            *\n* Hallo Eva! *\n*            *\n**************\n");
}
